#include <stdio.h>
#include <stdlib.h>

typedef struct vrchol{
	int cislo;
	int pocet_susedia;
	int susedia[4];
}
VRCHOL;


void inicializacia(int n, VRCHOL *vstup)
{
	int i, j;
	
	for( i = 0; i < n; i++ )
	{
		vstup[i].cislo = 0;	
		vstup[i].pocet_susedia = 0;
		for( j = 0; j < 4; j++ )
		{
			vstup[i].susedia[j] = 0;
		}		
	}
}

VRCHOL *nacitanie(int n, int m)
{
	vstup = (VRCHOL *)malloc(sizeof(VRCHOL) * n);
	
	inicializacia(n, vstup);
	
	return vstup;		
}

int naplnenie(VRCHOL *vstup, int x, int y)
{
	if(vstup->cislo == 0 && vstup->cislo != x)
	{
		vstup->cislo = x;
		vstup->susedia[vstup.pocet_susedia] = y;
		vstup->pocet_susedia++;
		if( vstup.pocet_susedia == 4 )
			return 0;
		else
			return 1;	
		
	}
}

int main()
{
	VRCHOL *v;
	int m, n, i, j;
	scanf("%d %d", &n, &m);

	if( n < 5 || m < 4 )
	{
		for( i = 0; i < m; i++ )
		{
			scanf("%d %d\n");
		}
		printf("NO\n");
	}
	else
	{
		v = nacitanie(n, m);
		for( i = 0; i < m; i++ )
		{
			scanf("%d %d", &x, &y);
			for( j = 0; j < n; j++ )
			{
				if(v[j].cislo != x)
					naplnenie(v[j], x, y);
	
			}
				
			
		}
		
	}

	return 0;
}
